package com.jdc.jdcproject.controller;

import com.jdc.jdcproject.entity.FangpaishuiPumpoperationrecord;
import com.jdc.jdcproject.entity.FangpaishuiUnit;
import com.jdc.jdcproject.entity.FangpaishuiWatertreatmentrecord;
import com.jdc.jdcproject.entity.VO.*;
import com.jdc.jdcproject.service.EquipmentService;
import com.jdc.jdcproject.service.FangpaishuiPumpoperationrecordService;
import com.jdc.jdcproject.utils.LastDayOfMonth;
import com.jdc.jdcproject.utils.Result;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.sql.SQLOutput;
import java.text.ParseException;
import java.time.Instant;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.*;
import java.util.stream.Collectors;

@RestController
@RequestMapping("/FangpaishuiPumpoperationrecordController")
public class FangpaishuiPumpoperationrecordController {
    @Autowired
    private FangpaishuiPumpoperationrecordService fangpaishuiPumpoperationrecordService;

    @Operation(summary = "根据条件查询水泵运行日志")
    @PostMapping("findPumpoperationrecordByDetail")
    public Result findPumpoperationrecordByDetail(@RequestBody FangpaishuiPumpoperationrecordVo fangpaishuiPumpoperationrecordVo) {
        List<FangpaishuiPumpoperationrecordVo> vos = fangpaishuiPumpoperationrecordService.findDetail(fangpaishuiPumpoperationrecordVo);
        return Result.successResult().data("vos", vos);
    }
    @Operation(summary = "新增水泵运行日志")
    @PostMapping("addFangpaishuiPumpoperationrecord")
    public Result addFangpaishuiPumpoperationrecord(@RequestBody FangpaishuiPumpoperationrecord fangpaishuiPumpoperationrecord) {
        Date date = new Date();
        Instant instant = date.toInstant();
        ZoneId zoneId = ZoneId.systemDefault();
        LocalDate localDate = instant.atZone(zoneId).toLocalDate();
        fangpaishuiPumpoperationrecord.setMonth(localDate);
        //计算小时差并写入操作时间
        Long start = fangpaishuiPumpoperationrecord.getStartupTime().getTime();
        Long end = fangpaishuiPumpoperationrecord.getEndTime().getTime();
        int minutes = (int) ((end - start) / (1000 * 60));
        fangpaishuiPumpoperationrecord.setOperationTime((double) (minutes/60));
        System.out.println(fangpaishuiPumpoperationrecord);

        boolean updateflag = fangpaishuiPumpoperationrecordService.save(fangpaishuiPumpoperationrecord);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

    @Operation(summary = "删除水泵运行日志")
    @DeleteMapping("deleteFangpaishuiPumpoperationrecord/{id}")
    public Result deleteFangpaishuiPumpoperationrecord(@PathVariable int id) {
        boolean updateflag = fangpaishuiPumpoperationrecordService.removeById(id);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

    @Operation(summary = "修改水泵运行日志")
    @PostMapping("updateFangpaishuiPumpoperationrecord")
    public Result updateFangpaishuiPumpoperationrecord(@RequestBody FangpaishuiPumpoperationrecord fangpaishuiPumpoperationrecord) {
        //计算小时差并写入操作时间
        Long start = fangpaishuiPumpoperationrecord.getStartupTime().getTime();
        Long end = fangpaishuiPumpoperationrecord.getEndTime().getTime();
        int minutes = (int) ((end - start) / (1000 * 60));
        fangpaishuiPumpoperationrecord.setOperationTime((double) (minutes/60));
        boolean updateflag = fangpaishuiPumpoperationrecordService.updateById(fangpaishuiPumpoperationrecord);
        if (updateflag) {
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

    @Operation(summary = "根据月查询排/倒水月报表")
    @GetMapping("findFangpaishuiPumpoperationrecordByMonth/{date}")
    public Result findWatertreatmentrecordByMonth(@PathVariable String date) throws ParseException {
        String[] s = date.split("-");
        int year = Integer.parseInt(s[0]);
        int month = Integer.parseInt(s[1]);
        LastDayOfMonth lastDayOfMonth = new LastDayOfMonth();
        String upDay =  lastDayOfMonth.getLastDayOfMonth(year, month-1);
        String lastDay =  lastDayOfMonth.getLastDayOfMonth(year, month);
        upDay =  lastDayOfMonth.dateCalculations(upDay,5);
        lastDay =  lastDayOfMonth.dateCalculations(lastDay,6);
        FangpaishuiPumpoperationrecordReportByYearCountVo fangpaishuiPumpoperationrecordReportByYearCountVo =fangpaishuiPumpoperationrecordService.findAll(upDay,lastDay);



 return Result.successResult().data("fangpaishuiPumpoperationrecordReportByYearCountVo",fangpaishuiPumpoperationrecordReportByYearCountVo);
    }
}
