package com.jdc.jdcproject.entity.VO;

import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.time.LocalDate;
@Data
public class DicekeTotalMiningVo {

    private static final long serialVersionUID = 1L;

    @Schema(description = "TotalID") /*传LossID,涉及修改或删除Loss表*/
    @TableId("TotalID")
    private String TotalID;

    @Schema(description = "外键关联平盘表")
    private String plateID;

    @Schema(description = "外键关联铲号表")
    private String shovelID;

    @Schema(description = "备注")
    private String beizhu;

 /*
    @Schema(description = "计量单位")
    private String UOM;
*/
    @Schema(description = "出矿量（吨）")
    private Double OreYield;

    @Schema(description = "剥离量（吨）")
    private Double strippingTon;

    @Schema(description = "采剥总量（吨）")
    private Double strippingAndTotalMiningTon;

    @Schema(description = "月份",name="月份")
    private LocalDate month;

    public DicekeTotalMiningVo(String totalID,
                               String plateID,
                               String shovelID,
                               String beizhu,
                               String UOM,
                               Double oreYield,
                               Double strippingTon,
                               Double strippingAndTotalMiningTon,
                               LocalDate month) {
        TotalID = totalID;
        this.plateID = plateID;
        this.shovelID = shovelID;
        this.beizhu = beizhu;
//        this.UOM = UOM;
        OreYield = oreYield;
        this.strippingTon = strippingTon;
        this.strippingAndTotalMiningTon = strippingAndTotalMiningTon;
        this.month = month;
    }

    @Override
    public String toString() {
        return "DicekeTotalMiningVo{" +
                "TotalID='" + TotalID + '\'' +
                ", plateID='" + plateID + '\'' +
                ", shovelID='" + shovelID + '\'' +
                ", beizhu='" + beizhu + '\'' +
//                ", UOM='" + UOM + '\'' +
                ", OreYield=" + OreYield +
                ", strippingTon=" + strippingTon +
                ", strippingAndTotalMiningTon=" + strippingAndTotalMiningTon +
                ", month=" + month +
                '}';
    }
}
